﻿import demo.undo.Memento;
import mx.events.EventDispatcher;

class demo.undo.CareTaker {
// private properties
	private var __index:Number;
	private var journal:Array;
	
// methods for EventDispatcher:
	private var dispatchEvent:Function;
	public var addEventListener:Function;
	public var removeEventListener:Function;

// initialization:
	function CareTaker() {
		clear();
		EventDispatcher.initialize(this);
	}
	
// public methods:
	// begins listening for change events from an originator:
	public function addOriginator(p_originator:Object):Void {
		p_originator.addEventListener("change",this);
	}
	
	// clears the entire journal
	public function clear() {
		__index = 0;
		journal = [];
		dispatchEvent({type:"change"});
		dispatchEvent({type:"changeIndex"});
	}
	
	// moves back one point in history
	public function undo():Void {
		index--;
	}
	
	// moves forwards one point in history
	public function redo():Void {
		index++;
	}
	
	// returns a dataProvider for display in list components:
	public function getDataProvider():Array {
		var dp:Array = [];
		var l:Number = journal.length;
		for (var i:Number=0;i<l;i++) {
			dp.push({label:journal[i].label,index:i});
		}
		return dp;
	}
	
// getter/setters:
	// gets the current point in history
	public function get index():Number {
		return __index;
	}
	// sets the current point in history, and passes back the memento to get there.
	public function set index(p_index:Number):Void {
		var n = Math.max(0,Math.min(p_index,journal.length-1));
		if (n==index) { return; }
		// restore the state:
		journal[n].originator.setMemento(journal[n]);
		__index = n;
		dispatchEvent({type:"changeIndex"});
	}
	
// semi-public methods:
	function change(p_evtObj:Object):Void {
		push(p_evtObj.target.createMemento());
	}
	
// private methods:
	// method that adds entries:
	private function push(p_memento:Memento) {
		var j:Number = index;
		journal.splice(j+1,journal.length-j,p_memento);
		__index = journal.length-1;
		dispatchEvent({type:"change"});
		dispatchEvent({type:"changeIndex"});
	}

}