﻿import demo.undo.CareTaker;
import mx.controls.Button;
import mx.controls.List;

class demo.views.HistoryPalette {
// private properties:
	private var careTaker:CareTaker;
	
// ui elements:
	private var history:List;
	private var undoBtn:Button;
	private var redoBtn:Button;
	private var clearBtn:Button;
	
// initialization:
	private function HistoryPalette() {
		
	}
	
	private function onLoad() {
		configureUI();
	}
	private function configureUI():Void {
		// set up the buttons:
		undoBtn.clickHandler = function() { this._parent.careTaker.undo(); }
		redoBtn.clickHandler = function() { this._parent.careTaker.redo(); }
		clearBtn.clickHandler = function() { this._parent.careTaker.clear(); }
		
		// set up the history list:
		var historyListener:Object = {owner:this};
		historyListener.change = function(p_evtObj:Object) {
			this.owner.careTaker.index = p_evtObj.target.selectedIndex;
		}
		history.addEventListener("change",historyListener);
	}
	
// public methods:
	public function registerCareTaker(p_careTaker:CareTaker):Void {
		careTaker = p_careTaker;
		careTaker.addEventListener("change",this);
		careTaker.addEventListener("changeIndex",this);
	}
	
// private methods:
	private function changeIndex(p_evtObj:Object):Void {
		trace("changeIndex");
		history.selectedIndex = careTaker.index;
	}
	private function change(p_evtObj:Object) {
		trace("change");
		history.dataProvider = careTaker.getDataProvider();
	}
}